Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 3550)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 3551)
@@ -3057,17 +3202,19 @@
 !--       Calculate the divergence of the velocity field. A respective
 !--       correction is needed to overcome numerical instabilities introduced
-!--       by a not sufficient reduction of divergences near topography. 
+!--       by a not sufficient reduction of divergences near topography.
           div = ( ( ( u_comp(k) + gu ) * ( ibit27 + ibit28 + ibit29 )         &
                   - ( u(k+1,j,i) + u(k,j,i)   )                               & 
-                                    * ( IBITS(advc_flags_1(k,j,i-1),27,1)     &
-                                      + IBITS(advc_flags_1(k,j,i-1),28,1)     &
-                                      + IBITS(advc_flags_1(k,j,i-1),29,1)     &
+                                    * (                                       &
+                     REAL( IBITS(advc_flags_1(k,j,i-1),27,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k,j,i-1),28,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k,j,i-1),29,1), KIND = wp )     &
                                       )                                       &
                   ) * ddx                                                     &
               +   ( ( v_comp(k) + gv ) * ( ibit30 + ibit31 + ibit32 )         & 
                   - ( v(k+1,j,i) + v(k,j,i)   )                               &
-                                    * ( IBITS(advc_flags_1(k,j-1,i),30,1)     &
-                                      + IBITS(advc_flags_1(k,j-1,i),31,1)     &
-                                      + IBITS(advc_flags_2(k,j-1,i),0,1)      &
+                                    * (                                       &
+                     REAL( IBITS(advc_flags_1(k,j-1,i),30,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_1(k,j-1,i),31,1), KIND = wp )     &
+                   + REAL( IBITS(advc_flags_2(k,j-1,i),0,1),  KIND = wp )     &
                                       )                                       &
                   ) * ddy                                                     &
@@ -3075,117 +3222,9 @@
                                             * ( ibit33 + ibit34 + ibit35 )    &
                 - ( w(k,j,i) + w(k-1,j,i) ) * rho_air(k)                      &
-                                    * ( IBITS(advc_flags_2(k-1,j,i),1,1)      &
-                                      + IBITS(advc_flags_2(k-1,j,i),2,1)      &
-                                      + IBITS(advc_flags_2(k-1,j,i),3,1)      &
+                                    * (                                       &
+                     REAL( IBITS(advc_flags_2(k-1,j,i),1,1), KIND = wp )      &
+                   + REAL( IBITS(advc_flags_2(k-1,j,i),2,1), KIND = wp )      &
+                   + REAL( IBITS(advc_flags_2(k-1,j,i),3,1), KIND = wp )      &
                                       )                                       & 
-                  ) * drho_air_zw(k) * ddzu(k+1)                              &
-                ) * 0.5_wp
-
-
-          tend(k,j,i) = tend(k,j,i) - (                                       &
-                      ( flux_r(k) + diss_r(k)                                 &
-                    -   flux_l_w(k,j,tn) - diss_l_w(k,j,tn)   ) * ddx         &
-                    + ( flux_n(k) + diss_n(k)                                 &
-                    -   flux_s_w(k,tn) - diss_s_w(k,tn)       ) * ddy         &
-                    + ( ( flux_t(k) + diss_t(k) )                             &
-                    -   ( flux_d    + diss_d    )                             &
-                                              ) * drho_air_zw(k) * ddzu(k+1)  &
-                                      ) + div * w(k,j,i)
-
-          flux_l_w(k,j,tn) = flux_r(k)
-          diss_l_w(k,j,tn) = diss_r(k)
-          flux_s_w(k,tn)   = flux_n(k)
-          diss_s_w(k,tn)   = diss_n(k)
-!
-!--       Statistical Evaluation of w'w'.
-          sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                          &
-                      + ( flux_t(k)                                           &
-                       * ( w_comp(k) - 2.0_wp * hom(k,1,3,0)                ) &
-                       / ( w_comp(k) + SIGN( 1.0E-20_wp, w_comp(k) )        ) &
-                        + diss_t(k)                                           &
-                       *   ABS( w_comp(k) - 2.0_wp * hom(k,1,3,0)           ) &
-                       / ( ABS( w_comp(k) ) + 1.0E-20_wp                    ) &
-                        ) *   weight_substep(intermediate_timestep_count)
-
-       ENDDO
-
-       DO  k = nzb_max+1, nzt
-
-          u_comp(k) = u(k+1,j,i+1) + u(k,j,i+1) - gu
-          flux_r(k) = u_comp(k) * (                                           &
-                      37.0_wp * ( w(k,j,i+1) + w(k,j,i)   )                   &
-                    -  8.0_wp * ( w(k,j,i+2) + w(k,j,i-1) )                   &
-                    +           ( w(k,j,i+3) + w(k,j,i-2) ) ) * adv_mom_5
-
-          diss_r(k) = - ABS( u_comp(k) ) * (                                  &
-                      10.0_wp * ( w(k,j,i+1) - w(k,j,i)   )                   &
-                    -  5.0_wp * ( w(k,j,i+2) - w(k,j,i-1) )                   &
-                    +           ( w(k,j,i+3) - w(k,j,i-2) ) ) * adv_mom_5
-
-          v_comp(k) = v(k+1,j+1,i) + v(k,j+1,i) - gv
-          flux_n(k) = v_comp(k) * (                                           &
-                      37.0_wp * ( w(k,j+1,i) + w(k,j,i)   )                   &
-                    -  8.0_wp * ( w(k,j+2,i) + w(k,j-1,i) )                   &
-                    +           ( w(k,j+3,i) + w(k,j-2,i) ) ) * adv_mom_5
-
-          diss_n(k) = - ABS( v_comp(k) ) * (                                  &
-                      10.0_wp * ( w(k,j+1,i) - w(k,j,i)   )                   &
-                    -  5.0_wp * ( w(k,j+2,i) - w(k,j-1,i) )                   &
-                    +           ( w(k,j+3,i) - w(k,j-2,i) ) ) * adv_mom_5
-!
-!--       k index has to be modified near bottom and top, else array
-!--       subscripts will be exceeded.
-          ibit35 = IBITS(advc_flags_2(k,j,i),3,1)
-          ibit34 = IBITS(advc_flags_2(k,j,i),2,1)
-          ibit33 = IBITS(advc_flags_2(k,j,i),1,1)
-
-          k_ppp = k + 3 * ibit35
-          k_pp  = k + 2 * ( 1 - ibit33  )
-          k_mm  = k - 2 * ibit35
-
-          w_comp(k) = w(k+1,j,i) + w(k,j,i)
-          flux_t(k) = w_comp(k) * rho_air(k+1) * (                            &
-                     ( 37.0_wp * ibit35 * adv_mom_5                           &
-                  +     7.0_wp * ibit34 * adv_mom_3                           &
-                  +              ibit33 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( w(k+1,j,i)  + w(k,j,i)     )                &
-              -      (  8.0_wp * ibit35 * adv_mom_5                           &
-                  +              ibit34 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( w(k_pp,j,i)  + w(k-1,j,i)  )                &
-              +      (           ibit35 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( w(k_ppp,j,i) + w(k_mm,j,i) )                &
-                                                 )
-
-          diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (                   &
-                     ( 10.0_wp * ibit35 * adv_mom_5                           &
-                  +     3.0_wp * ibit34 * adv_mom_3                           &
-                  +              ibit33 * adv_mom_1                           &
-                     ) *                                                      &
-                                ( w(k+1,j,i)   - w(k,j,i)    )                &
-              -      (  5.0_wp * ibit35 * adv_mom_5                           &
-                  +              ibit34 * adv_mom_3                           &
-                     ) *                                                      &
-                                ( w(k_pp,j,i)  - w(k-1,j,i)  )                &
-              +      (           ibit35 * adv_mom_5                           &
-                     ) *                                                      &
-                                ( w(k_ppp,j,i) - w(k_mm,j,i) )                &
-                                                          )
-       ENDDO
-
-       DO  k = nzb_max+1, nzt
-
-          flux_d    = flux_t(k-1)
-          diss_d    = diss_t(k-1)
-!
-!--       Calculate the divergence of the velocity field. A respective
-!--       correction is needed to overcome numerical instabilities introduced
-!--       by a not sufficient reduction of divergences near topography.
-          div = ( ( u_comp(k) + gu - ( u(k+1,j,i) + u(k,j,i)   ) ) * ddx      &
-              +   ( v_comp(k) + gv - ( v(k+1,j,i) + v(k,j,i)   ) ) * ddy      &
-              +   ( w_comp(k)               * rho_air(k+1) -                  &
-                  ( w(k,j,i) + w(k-1,j,i) ) * rho_air(k)                      &
                   ) * drho_air_zw(k) * ddzu(k+1)                              &
                 ) * 0.5_wp
@@ -3260,13 +3299,4 @@
        
        INTEGER(iwp) ::  i      !< grid index along x-direction
-       INTEGER(iwp) ::  ibit0  !< flag indicating 1st-order scheme along x-direction
-       INTEGER(iwp) ::  ibit1  !< flag indicating 3rd-order scheme along x-direction
-       INTEGER(iwp) ::  ibit2  !< flag indicating 5th-order scheme along x-direction
-       INTEGER(iwp) ::  ibit3  !< flag indicating 1st-order scheme along y-direction
-       INTEGER(iwp) ::  ibit4  !< flag indicating 3rd-order scheme along y-direction
-       INTEGER(iwp) ::  ibit5  !< flag indicating 5th-order scheme along y-direction
-       INTEGER(iwp) ::  ibit6  !< flag indicating 1st-order scheme along z-direction
-       INTEGER(iwp) ::  ibit7  !< flag indicating 3rd-order scheme along z-direction
-       INTEGER(iwp) ::  ibit8  !< flag indicating 5th-order scheme along z-direction
        INTEGER(iwp) ::  j      !< grid index along y-direction
        INTEGER(iwp) ::  k      !< grid index along z-direction
@@ -3276,10 +3306,21 @@
        INTEGER(iwp) ::  tn = 0 !< number of OpenMP thread
        
-#if defined( __nopointer )
-       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !< advected scalar
-#else
-       REAL(wp), DIMENSION(:,:,:), POINTER ::  sk !< advected scalar
-#endif
-
+!       
+!--    sk is an array from parameter list. It should not be a pointer, because 
+!--    in that case the compiler can not assume a stride 1 and cannot perform 
+!--    a strided one vector load. Adding the CONTIGUOUS keyword makes things 
+!--    even worse, because the compiler cannot assume strided one in the 
+!--    caller side.
+       REAL(wp), INTENT(IN),DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !<  advected scalar
+
+       REAL(wp) ::  ibit0  !< flag indicating 1st-order scheme along x-direction
+       REAL(wp) ::  ibit1  !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp) ::  ibit2  !< flag indicating 5th-order scheme along x-direction
+       REAL(wp) ::  ibit3  !< flag indicating 1st-order scheme along y-direction
+       REAL(wp) ::  ibit4  !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp) ::  ibit5  !< flag indicating 5th-order scheme along y-direction
+       REAL(wp) ::  ibit6  !< flag indicating 1st-order scheme along z-direction
+       REAL(wp) ::  ibit7  !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp) ::  ibit8  !< flag indicating 5th-order scheme along z-direction
        REAL(wp) ::  diss_d !< artificial dissipation term at grid box bottom 
        REAL(wp) ::  div    !< diverence on scalar grid
@@ -3309,7 +3350,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit2 = IBITS(advc_flags_1(k,j,i-1),2,1)
-             ibit1 = IBITS(advc_flags_1(k,j,i-1),1,1)
-             ibit0 = IBITS(advc_flags_1(k,j,i-1),0,1)
+             ibit2 = REAL( IBITS(advc_flags_1(k,j,i-1),2,1), KIND = wp )
+             ibit1 = REAL( IBITS(advc_flags_1(k,j,i-1),1,1), KIND = wp )
+             ibit0 = REAL( IBITS(advc_flags_1(k,j,i-1),0,1), KIND = wp )
 
              u_comp                 = u(k,j,i) - u_gtrans + u_stokes_zu(k)
@@ -3370,7 +3411,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit5 = IBITS(advc_flags_1(k,j-1,i),5,1)
-             ibit4 = IBITS(advc_flags_1(k,j-1,i),4,1)
-             ibit3 = IBITS(advc_flags_1(k,j-1,i),3,1)
+             ibit5 = REAL( IBITS(advc_flags_1(k,j-1,i),5,1), KIND = wp )
+             ibit4 = REAL( IBITS(advc_flags_1(k,j-1,i),4,1), KIND = wp )
+             ibit3 = REAL( IBITS(advc_flags_1(k,j-1,i),3,1), KIND = wp )
 
              v_comp               = v(k,j,i) - v_gtrans + v_stokes_zu(k)
@@ -3433,7 +3474,7 @@
              DO  k = nzb+1, nzb_max
 
-                ibit2 = IBITS(advc_flags_1(k,j,i),2,1)
-                ibit1 = IBITS(advc_flags_1(k,j,i),1,1)
-                ibit0 = IBITS(advc_flags_1(k,j,i),0,1)
+                ibit2 = REAL( IBITS(advc_flags_1(k,j,i),2,1), KIND = wp )
+                ibit1 = REAL( IBITS(advc_flags_1(k,j,i),1,1), KIND = wp )
+                ibit0 = REAL( IBITS(advc_flags_1(k,j,i),0,1), KIND = wp )
 
                 u_comp    = u(k,j,i+1) - u_gtrans + u_stokes_zu(k)
@@ -3468,7 +3509,7 @@
                                              )
 
-                ibit5 = IBITS(advc_flags_1(k,j,i),5,1)
-                ibit4 = IBITS(advc_flags_1(k,j,i),4,1)
-                ibit3 = IBITS(advc_flags_1(k,j,i),3,1)
+                ibit5 = REAL( IBITS(advc_flags_1(k,j,i),5,1), KIND = wp )
+                ibit4 = REAL( IBITS(advc_flags_1(k,j,i),4,1), KIND = wp )
+                ibit3 = REAL( IBITS(advc_flags_1(k,j,i),3,1), KIND = wp )
 
                 v_comp    = v(k,j+1,i) - v_gtrans + v_stokes_zu(k)
@@ -3505,7 +3546,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit8 = IBITS(advc_flags_1(k,j,i),8,1)
-                ibit7 = IBITS(advc_flags_1(k,j,i),7,1)
-                ibit6 = IBITS(advc_flags_1(k,j,i),6,1)
+                ibit8 = REAL( IBITS(advc_flags_1(k,j,i),8,1), KIND = wp )
+                ibit7 = REAL( IBITS(advc_flags_1(k,j,i),7,1), KIND = wp )
+                ibit6 = REAL( IBITS(advc_flags_1(k,j,i),6,1), KIND = wp )
 
                 k_ppp = k + 3 * ibit8
@@ -3547,13 +3588,15 @@
 !--             by a not sufficient reduction of divergences near topography.
                 div   =   ( u(k,j,i+1) * ( ibit0 + ibit1 + ibit2 )             &
-                          - u(k,j,i)   * ( IBITS(advc_flags_1(k,j,i-1),0,1)    &
-                                         + IBITS(advc_flags_1(k,j,i-1),1,1)    &
-                                         + IBITS(advc_flags_1(k,j,i-1),2,1)    &
+                          - u(k,j,i)   * (                                     &
+                        REAL( IBITS(advc_flags_1(k,j,i-1),0,1), KIND = wp )    &
+                      + REAL( IBITS(advc_flags_1(k,j,i-1),1,1), KIND = wp )    &
+                      + REAL( IBITS(advc_flags_1(k,j,i-1),2,1), KIND = wp )    &
                                          )                                     &
                           ) * ddx                                              &
                         + ( v(k,j+1,i) * ( ibit3 + ibit4 + ibit5 )             &
-                          - v(k,j,i)   * ( IBITS(advc_flags_1(k,j-1,i),3,1)    &
-                                         + IBITS(advc_flags_1(k,j-1,i),4,1)    &
-                                         + IBITS(advc_flags_1(k,j-1,i),5,1)    &
+                          - v(k,j,i)   * (                                     &
+                        REAL( IBITS(advc_flags_1(k,j-1,i),3,1), KIND = wp )    &
+                      + REAL( IBITS(advc_flags_1(k,j-1,i),4,1), KIND = wp )    &
+                      + REAL( IBITS(advc_flags_1(k,j-1,i),5,1), KIND = wp )    &
                                          )                                     &
                           ) * ddy                                              &
@@ -3561,7 +3604,8 @@
                                          ( ibit6 + ibit7 + ibit8 )             &
                           - w(k-1,j,i) * rho_air_zw(k-1) *                     &
-                                         ( IBITS(advc_flags_1(k-1,j,i),6,1)    &
-                                         + IBITS(advc_flags_1(k-1,j,i),7,1)    &
-                                         + IBITS(advc_flags_1(k-1,j,i),8,1)    &
+                                         (                                     &
+                        REAL( IBITS(advc_flags_1(k-1,j,i),6,1), KIND = wp )    &
+                      + REAL( IBITS(advc_flags_1(k-1,j,i),7,1), KIND = wp )    &
+                      + REAL( IBITS(advc_flags_1(k-1,j,i),8,1), KIND = wp )    &
                                          )                                     &      
                           ) * drho_air(k) * ddzw(k)
@@ -3611,7 +3655,7 @@
 !--             k index has to be modified near bottom and top, else array
 !--             subscripts will be exceeded.
-                ibit8 = IBITS(advc_flags_1(k,j,i),8,1)
-                ibit7 = IBITS(advc_flags_1(k,j,i),7,1)
-                ibit6 = IBITS(advc_flags_1(k,j,i),6,1)
+                ibit8 = REAL( IBITS(advc_flags_1(k,j,i),8,1), KIND = wp )
+                ibit7 = REAL( IBITS(advc_flags_1(k,j,i),7,1), KIND = wp )
+                ibit6 = REAL( IBITS(advc_flags_1(k,j,i),6,1), KIND = wp )
 
                 k_ppp = k + 3 * ibit8
@@ -3817,13 +3861,4 @@
 
        INTEGER(iwp) ::  i      !< grid index along x-direction
-       INTEGER(iwp) ::  ibit9  !< flag indicating 1st-order scheme along x-direction
-       INTEGER(iwp) ::  ibit10 !< flag indicating 3rd-order scheme along x-direction
-       INTEGER(iwp) ::  ibit11 !< flag indicating 5th-order scheme along x-direction
-       INTEGER(iwp) ::  ibit12 !< flag indicating 1st-order scheme along y-direction
-       INTEGER(iwp) ::  ibit13 !< flag indicating 3rd-order scheme along y-direction
-       INTEGER(iwp) ::  ibit14 !< flag indicating 5th-order scheme along y-direction
-       INTEGER(iwp) ::  ibit15 !< flag indicating 1st-order scheme along z-direction
-       INTEGER(iwp) ::  ibit16 !< flag indicating 3rd-order scheme along z-direction
-       INTEGER(iwp) ::  ibit17 !< flag indicating 5th-order scheme along z-direction
        INTEGER(iwp) ::  j      !< grid index along y-direction
        INTEGER(iwp) ::  k      !< grid index along z-direction
@@ -3833,4 +3868,13 @@
        INTEGER(iwp) ::  tn = 0 !< number of OpenMP thread
        
+       REAL(wp)    ::  ibit9  !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit10 !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit11 !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)    ::  ibit12 !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit13 !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit14 !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)    ::  ibit15 !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)    ::  ibit16 !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)    ::  ibit17 !< flag indicating 5th-order scheme along z-direction
        REAL(wp)    ::  diss_d !< artificial dissipation term at grid box bottom
        REAL(wp)    ::  div    !< diverence on u-grid
@@ -3864,20 +3908,20 @@
           DO  k = nzb+1, nzb_max
 
-             ibit11 = IBITS(advc_flags_1(k,j,i-1),11,1)
-             ibit10 = IBITS(advc_flags_1(k,j,i-1),10,1)
-             ibit9  = IBITS(advc_flags_1(k,j,i-1),9,1)
+             ibit11 = REAL( IBITS(advc_flags_1(k,j,i-1),11,1), KIND = wp )
+             ibit10 = REAL( IBITS(advc_flags_1(k,j,i-1),10,1), KIND = wp )
+             ibit9  = REAL( IBITS(advc_flags_1(k,j,i-1),9,1),  KIND = wp )
 
              u_comp(k)                = u(k,j,i) + u(k,j,i-1) - gu
              swap_flux_x_local_u(k,j) = u_comp(k) * (                          &
-                                       ( 37.0_wp * ibit11 * adv_mom_5             &
-                                    +     7.0_wp * ibit10 * adv_mom_3             &
-                                    +              ibit9  * adv_mom_1             &
+                                       ( 37.0_wp * ibit11 * adv_mom_5          &
+                                    +     7.0_wp * ibit10 * adv_mom_3          &
+                                    +              ibit9  * adv_mom_1          &
                                        ) *                                     &
                                      ( u(k,j,i)   + u(k,j,i-1) )               &
-                                -      (  8.0_wp * ibit11 * adv_mom_5             &
-                                    +              ibit10 * adv_mom_3             &
+                                -      (  8.0_wp * ibit11 * adv_mom_5          &
+                                    +              ibit10 * adv_mom_3          &
                                        ) *                                     &
                                      ( u(k,j,i+1) + u(k,j,i-2) )               &
-                                +      (           ibit11 * adv_mom_5             &
+                                +      (           ibit11 * adv_mom_5          &
                                        ) *                                     &
                                      ( u(k,j,i+2) + u(k,j,i-3) )               &
@@ -3885,14 +3929,14 @@
 
               swap_diss_x_local_u(k,j) = - ABS( u_comp(k) ) * (                &
-                                       ( 10.0_wp * ibit11 * adv_mom_5             &
-                                    +     3.0_wp * ibit10 * adv_mom_3             &
-                                    +              ibit9  * adv_mom_1             &
+                                       ( 10.0_wp * ibit11 * adv_mom_5          &
+                                    +     3.0_wp * ibit10 * adv_mom_3          &
+                                    +              ibit9  * adv_mom_1          &
                                        ) *                                     &
                                      ( u(k,j,i)   - u(k,j,i-1) )               &
-                                -      (  5.0_wp * ibit11 * adv_mom_5             &
-                                    +              ibit10 * adv_mom_3             &
+                                -      (  5.0_wp * ibit11 * adv_mom_5          &
+                                    +              ibit10 * adv_mom_3          &
                                        ) *                                     &
                                      ( u(k,j,i+1) - u(k,j,i-2) )               &
-                                +      (           ibit11 * adv_mom_5             &
+                                +      (           ibit11 * adv_mom_5          &
                                        ) *                                     &
                                      ( u(k,j,i+2) - u(k,j,i-3) )               &
@@ -3905,10 +3949,10 @@
              u_comp(k)         = u(k,j,i) + u(k,j,i-1) - gu
              swap_flux_x_local_u(k,j) = u_comp(k) * (                          &
-                             37.0_wp * ( u(k,j,i) + u(k,j,i-1)   )                &
-                           -  8.0_wp * ( u(k,j,i+1) + u(k,j,i-2) )                &
+                             37.0_wp * ( u(k,j,i) + u(k,j,i-1)   )             &
+                           -  8.0_wp * ( u(k,j,i+1) + u(k,j,i-2) )             &
                            +           ( u(k,j,i+2) + u(k,j,i-3) ) ) * adv_mom_5
              swap_diss_x_local_u(k,j) = - ABS(u_comp(k)) * (                   &
-                             10.0_wp * ( u(k,j,i) - u(k,j,i-1)   )                &
-                           -  5.0_wp * ( u(k,j,i+1) - u(k,j,i-2) )                &
+                             10.0_wp * ( u(k,j,i) - u(k,j,i-1)   )             &
+                           -  5.0_wp * ( u(k,j,i+1) - u(k,j,i-2) )             &
                            +           ( u(k,j,i+2) - u(k,j,i-3) ) ) * adv_mom_5
 
@@ -3922,20 +3966,20 @@
           DO  k = nzb+1, nzb_max
 
-             ibit14 = IBITS(advc_flags_1(k,j-1,i),14,1)
-             ibit13 = IBITS(advc_flags_1(k,j-1,i),13,1)
-             ibit12 = IBITS(advc_flags_1(k,j-1,i),12,1)
+             ibit14 = REAL( IBITS(advc_flags_1(k,j-1,i),14,1), KIND = wp )
+             ibit13 = REAL( IBITS(advc_flags_1(k,j-1,i),13,1), KIND = wp )
+             ibit12 = REAL( IBITS(advc_flags_1(k,j-1,i),12,1), KIND = wp )
 
              v_comp                 = v(k,j,i) + v(k,j,i-1) - gv
              swap_flux_y_local_u(k) = v_comp * (                              &
-                                   ( 37.0_wp * ibit14 * adv_mom_5                &
-                                +     7.0_wp * ibit13 * adv_mom_3                &
-                                +              ibit12 * adv_mom_1                &
+                                   ( 37.0_wp * ibit14 * adv_mom_5             &
+                                +     7.0_wp * ibit13 * adv_mom_3             &
+                                +              ibit12 * adv_mom_1             &
                                    ) *                                        &
                                      ( u(k,j,i)   + u(k,j-1,i) )              &
-                            -      (  8.0_wp * ibit14 * adv_mom_5                &
-                            +                  ibit13 * adv_mom_3                    &
+                            -      (  8.0_wp * ibit14 * adv_mom_5             &
+                            +                  ibit13 * adv_mom_3             &
                                    ) *                                        &
                                      ( u(k,j+1,i) + u(k,j-2,i) )              &
-                        +      (               ibit14 * adv_mom_5                    &
+                        +      (               ibit14 * adv_mom_5             &
                                ) *                                            &
                                      ( u(k,j+2,i) + u(k,j-3,i) )              &
@@ -3943,14 +3987,14 @@
 
              swap_diss_y_local_u(k) = - ABS ( v_comp ) * (                    &
-                                   ( 10.0_wp * ibit14 * adv_mom_5                &
-                                +     3.0_wp * ibit13 * adv_mom_3                &
-                                +              ibit12 * adv_mom_1                &
+                                   ( 10.0_wp * ibit14 * adv_mom_5             &
+                                +     3.0_wp * ibit13 * adv_mom_3             &
+                                +              ibit12 * adv_mom_1             &
                                    ) *                                        &
                                      ( u(k,j,i)   - u(k,j-1,i) )              &
-                            -      (  5.0_wp * ibit14 * adv_mom_5                &
-                                +              ibit13 * adv_mom_3                &
+                            -      (  5.0_wp * ibit14 * adv_mom_5             &
+                                +              ibit13 * adv_mom_3             &
                                    ) *                                        &
                                      ( u(k,j+1,i) - u(k,j-2,i) )              &
-                            +      (           ibit14 * adv_mom_5                &
+                            +      (           ibit14 * adv_mom_5             &
                                    ) *                                        &
                                      ( u(k,j+2,i) - u(k,j-3,i) )              &
@@ -3983,20 +4027,20 @@
              DO  k = nzb+1, nzb_max
 
-                ibit11 = IBITS(advc_flags_1(k,j,i),11,1)
-                ibit10 = IBITS(advc_flags_1(k,j,i),10,1)
-                ibit9  = IBITS(advc_flags_1(k,j,i),9,1)
+                ibit11 = REAL( IBITS(advc_flags_1(k,j,i),11,1), KIND = wp )
+                ibit10 = REAL( IBITS(advc_flags_1(k,j,i),10,1), KIND = wp )
+                ibit9  = REAL( IBITS(advc_flags_1(k,j,i),9,1),  KIND = wp )
 
                 u_comp(k) = u(k,j,i+1) + u(k,j,i)
                 flux_r(k) = ( u_comp(k) - gu ) * (                           &
-                          ( 37.0_wp * ibit11 * adv_mom_5                        &
-                       +     7.0_wp * ibit10 * adv_mom_3                        &
-                       +              ibit9  * adv_mom_1                        &
+                          ( 37.0_wp * ibit11 * adv_mom_5                     &
+                       +     7.0_wp * ibit10 * adv_mom_3                     &
+                       +              ibit9  * adv_mom_1                     &
                           ) *                                                &
                                  ( u(k,j,i+1) + u(k,j,i)   )                 &
-                   -      (  8.0_wp * ibit11 * adv_mom_5                        &
-                       +              ibit10 * adv_mom_3                        &
+                   -      (  8.0_wp * ibit11 * adv_mom_5                     &
+                       +              ibit10 * adv_mom_3                     &
                           ) *                                                &
                                  ( u(k,j,i+2) + u(k,j,i-1) )                 &
-                   +      (           ibit11 * adv_mom_5                        &
+                   +      (           ibit11 * adv_mom_5                     &
                           ) *                                                &
                                  ( u(k,j,i+3) + u(k,j,i-2) )                 &
